/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB Code Configurator - v2.25.2
        Device            :  PIC16F1708
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#include "mcc_generated_files/mcc.h"

inline void led_set(char mask);

char sineTable[] = { 127,139,151,163,175,186,197,207,216,225,232,239,244,248,251,253,254,253,251,248,244,239,232,225,216,207,197,186,175,163,151,139,126,114,102,90,78,67,56,46,37,28,21,14,9,5,2,0,0,0,2,5,9,14,21,28,37,46,56,67,78,90,102,114 };
/*
                         Main application
 */
void main(void) {
    char sine_output = 0;
    char counter = 0;
    int adc_value = 0x3FF;
    long dc_temp;
    // initialize the device
    SYSTEM_Initialize();
    
    ADC_StartConversion(channel_POT);
    while (1) {
        if(ADC_IsConversionDone())
        {
            adc_value = ADC_GetConversionResult();
            ADC_StartConversion(channel_POT);
            led_set((1 << (adc_value >> 8)));
            adc_value = 1023 - adc_value;
        }
        if(TMR2_HasOverflowOccured())
        {
            counter += 1;
            counter &= 0x7F; // count to 128 and roll Over

            
            TMR2_LoadPeriodRegister(78 + (adc_value / 7));

            // ZCD Sine Wave
            sine_output = sineTable[counter>>1];
            DAC_SetOutput(sine_output);

            // single pulse AT waveform
//            if(counter)
//                RST_SetLow();
//            else // counter == 0
//                RST_SetHigh();
            
            // missing pulse AT waveform
            if(counter >> 1)
                CS_Toggle();
            else
                CS_SetLow();

            // SMT lab will only use DC.
            if(adc_value == 0) adc_value ++;
            if(adc_value >= 1000) adc_value = 1000;
            PWM3_LoadDutyValue(adc_value);

//            PWM4_Toggle();
        }
    }
}

inline void led_set(char mask)
{
    LED_D1_LAT = (mask & 0x01)?1:0;
    LED_D2_LAT = (mask & 0x02)?1:0;
    LED_D3_LAT = (mask & 0x04)?1:0;
    LED_D4_LAT = (mask & 0x08)?1:0;
}
/*
 End of File
 */