/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB? Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB? Code Configurator - v2.25.2
        Device            :  PIC16F1708
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set DACOUT1 aliases
#define DACOUT1_TRIS               TRISA0
#define DACOUT1_LAT                LATA0
#define DACOUT1_PORT               RA0
#define DACOUT1_WPU                WPUA0
#define DACOUT1_ANS                ANSA0
#define DACOUT1_SetHigh()    do { LATA0 = 1; } while(0)
#define DACOUT1_SetLow()   do { LATA0 = 0; } while(0)
#define DACOUT1_Toggle()   do { LATA0 = ~LATA0; } while(0)
#define DACOUT1_GetValue()         RA0
#define DACOUT1_SetDigitalInput()    do { TRISA0 = 1; } while(0)
#define DACOUT1_SetDigitalOutput()   do { TRISA0 = 0; } while(0)

#define DACOUT1_SetPullup()    do { WPUA0 = 1; } while(0)
#define DACOUT1_ResetPullup()   do { WPUA0 = 0; } while(0)
#define DACOUT1_SetAnalogMode()   do { ANSA0 = 1; } while(0)
#define DACOUT1_SetDigitalMode()   do { ANSA0 = 0; } while(0)
// get/set DACOUT2 aliases
#define DACOUT2_TRIS               TRISA2
#define DACOUT2_LAT                LATA2
#define DACOUT2_PORT               RA2
#define DACOUT2_WPU                WPUA2
#define DACOUT2_ANS                ANSA2
#define DACOUT2_SetHigh()    do { LATA2 = 1; } while(0)
#define DACOUT2_SetLow()   do { LATA2 = 0; } while(0)
#define DACOUT2_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define DACOUT2_GetValue()         RA2
#define DACOUT2_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define DACOUT2_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define DACOUT2_SetPullup()    do { WPUA2 = 1; } while(0)
#define DACOUT2_ResetPullup()   do { WPUA2 = 0; } while(0)
#define DACOUT2_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define DACOUT2_SetDigitalMode()   do { ANSA2 = 0; } while(0)
// get/set LED_D1 aliases
#define LED_D1_TRIS               TRISA4
#define LED_D1_LAT                LATA4
#define LED_D1_PORT               RA4
#define LED_D1_WPU                WPUA4
#define LED_D1_ANS                ANSA4
#define LED_D1_SetHigh()    do { LATA4 = 1; } while(0)
#define LED_D1_SetLow()   do { LATA4 = 0; } while(0)
#define LED_D1_Toggle()   do { LATA4 = ~LATA4; } while(0)
#define LED_D1_GetValue()         RA4
#define LED_D1_SetDigitalInput()    do { TRISA4 = 1; } while(0)
#define LED_D1_SetDigitalOutput()   do { TRISA4 = 0; } while(0)

#define LED_D1_SetPullup()    do { WPUA4 = 1; } while(0)
#define LED_D1_ResetPullup()   do { WPUA4 = 0; } while(0)
#define LED_D1_SetAnalogMode()   do { ANSA4 = 1; } while(0)
#define LED_D1_SetDigitalMode()   do { ANSA4 = 0; } while(0)
// get/set LED_D2 aliases
#define LED_D2_TRIS               TRISA5
#define LED_D2_LAT                LATA5
#define LED_D2_PORT               RA5
#define LED_D2_WPU                WPUA5
#define LED_D2_SetHigh()    do { LATA5 = 1; } while(0)
#define LED_D2_SetLow()   do { LATA5 = 0; } while(0)
#define LED_D2_Toggle()   do { LATA5 = ~LATA5; } while(0)
#define LED_D2_GetValue()         RA5
#define LED_D2_SetDigitalInput()    do { TRISA5 = 1; } while(0)
#define LED_D2_SetDigitalOutput()   do { TRISA5 = 0; } while(0)

#define LED_D2_SetPullup()    do { WPUA5 = 1; } while(0)
#define LED_D2_ResetPullup()   do { WPUA5 = 0; } while(0)
// get/set LED_D4 aliases
#define LED_D4_TRIS               TRISB4
#define LED_D4_LAT                LATB4
#define LED_D4_PORT               RB4
#define LED_D4_WPU                WPUB4
#define LED_D4_ANS                ANSB4
#define LED_D4_SetHigh()    do { LATB4 = 1; } while(0)
#define LED_D4_SetLow()   do { LATB4 = 0; } while(0)
#define LED_D4_Toggle()   do { LATB4 = ~LATB4; } while(0)
#define LED_D4_GetValue()         RB4
#define LED_D4_SetDigitalInput()    do { TRISB4 = 1; } while(0)
#define LED_D4_SetDigitalOutput()   do { TRISB4 = 0; } while(0)

#define LED_D4_SetPullup()    do { WPUB4 = 1; } while(0)
#define LED_D4_ResetPullup()   do { WPUB4 = 0; } while(0)
#define LED_D4_SetAnalogMode()   do { ANSB4 = 1; } while(0)
#define LED_D4_SetDigitalMode()   do { ANSB4 = 0; } while(0)
// get/set LED_D3 aliases
#define LED_D3_TRIS               TRISB5
#define LED_D3_LAT                LATB5
#define LED_D3_PORT               RB5
#define LED_D3_WPU                WPUB5
#define LED_D3_ANS                ANSB5
#define LED_D3_SetHigh()    do { LATB5 = 1; } while(0)
#define LED_D3_SetLow()   do { LATB5 = 0; } while(0)
#define LED_D3_Toggle()   do { LATB5 = ~LATB5; } while(0)
#define LED_D3_GetValue()         RB5
#define LED_D3_SetDigitalInput()    do { TRISB5 = 1; } while(0)
#define LED_D3_SetDigitalOutput()   do { TRISB5 = 0; } while(0)

#define LED_D3_SetPullup()    do { WPUB5 = 1; } while(0)
#define LED_D3_ResetPullup()   do { WPUB5 = 0; } while(0)
#define LED_D3_SetAnalogMode()   do { ANSB5 = 1; } while(0)
#define LED_D3_SetDigitalMode()   do { ANSB5 = 0; } while(0)
// get/set channel_POT aliases
#define channel_POT_TRIS               TRISC0
#define channel_POT_LAT                LATC0
#define channel_POT_PORT               RC0
#define channel_POT_WPU                WPUC0
#define channel_POT_ANS                ANSC0
#define channel_POT_SetHigh()    do { LATC0 = 1; } while(0)
#define channel_POT_SetLow()   do { LATC0 = 0; } while(0)
#define channel_POT_Toggle()   do { LATC0 = ~LATC0; } while(0)
#define channel_POT_GetValue()         RC0
#define channel_POT_SetDigitalInput()    do { TRISC0 = 1; } while(0)
#define channel_POT_SetDigitalOutput()   do { TRISC0 = 0; } while(0)

#define channel_POT_SetPullup()    do { WPUC0 = 1; } while(0)
#define channel_POT_ResetPullup()   do { WPUC0 = 0; } while(0)
#define channel_POT_SetAnalogMode()   do { ANSC0 = 1; } while(0)
#define channel_POT_SetDigitalMode()   do { ANSC0 = 0; } while(0)
// get/set OPA1OUT aliases
#define OPA1OUT_TRIS               TRISC2
#define OPA1OUT_LAT                LATC2
#define OPA1OUT_PORT               RC2
#define OPA1OUT_WPU                WPUC2
#define OPA1OUT_ANS                ANSC2
#define OPA1OUT_SetHigh()    do { LATC2 = 1; } while(0)
#define OPA1OUT_SetLow()   do { LATC2 = 0; } while(0)
#define OPA1OUT_Toggle()   do { LATC2 = ~LATC2; } while(0)
#define OPA1OUT_GetValue()         RC2
#define OPA1OUT_SetDigitalInput()    do { TRISC2 = 1; } while(0)
#define OPA1OUT_SetDigitalOutput()   do { TRISC2 = 0; } while(0)

#define OPA1OUT_SetPullup()    do { WPUC2 = 1; } while(0)
#define OPA1OUT_ResetPullup()   do { WPUC2 = 0; } while(0)
#define OPA1OUT_SetAnalogMode()   do { ANSC2 = 1; } while(0)
#define OPA1OUT_SetDigitalMode()   do { ANSC2 = 0; } while(0)
// get/set OPA2OUT aliases
#define OPA2OUT_TRIS               TRISC3
#define OPA2OUT_LAT                LATC3
#define OPA2OUT_PORT               RC3
#define OPA2OUT_WPU                WPUC3
#define OPA2OUT_ANS                ANSC3
#define OPA2OUT_SetHigh()    do { LATC3 = 1; } while(0)
#define OPA2OUT_SetLow()   do { LATC3 = 0; } while(0)
#define OPA2OUT_Toggle()   do { LATC3 = ~LATC3; } while(0)
#define OPA2OUT_GetValue()         RC3
#define OPA2OUT_SetDigitalInput()    do { TRISC3 = 1; } while(0)
#define OPA2OUT_SetDigitalOutput()   do { TRISC3 = 0; } while(0)

#define OPA2OUT_SetPullup()    do { WPUC3 = 1; } while(0)
#define OPA2OUT_ResetPullup()   do { WPUC3 = 0; } while(0)
#define OPA2OUT_SetAnalogMode()   do { ANSC3 = 1; } while(0)
#define OPA2OUT_SetDigitalMode()   do { ANSC3 = 0; } while(0)
// get/set CS aliases
#define CS_TRIS               TRISC4
#define CS_LAT                LATC4
#define CS_PORT               RC4
#define CS_WPU                WPUC4
#define CS_SetHigh()    do { LATC4 = 1; } while(0)
#define CS_SetLow()   do { LATC4 = 0; } while(0)
#define CS_Toggle()   do { LATC4 = ~LATC4; } while(0)
#define CS_GetValue()         RC4
#define CS_SetDigitalInput()    do { TRISC4 = 1; } while(0)
#define CS_SetDigitalOutput()   do { TRISC4 = 0; } while(0)

#define CS_SetPullup()    do { WPUC4 = 1; } while(0)
#define CS_ResetPullup()   do { WPUC4 = 0; } while(0)
// get/set PWM3OUT aliases
#define PWM3OUT_TRIS               TRISC6
#define PWM3OUT_LAT                LATC6
#define PWM3OUT_PORT               RC6
#define PWM3OUT_WPU                WPUC6
#define PWM3OUT_ANS                ANSC6
#define PWM3OUT_SetHigh()    do { LATC6 = 1; } while(0)
#define PWM3OUT_SetLow()   do { LATC6 = 0; } while(0)
#define PWM3OUT_Toggle()   do { LATC6 = ~LATC6; } while(0)
#define PWM3OUT_GetValue()         RC6
#define PWM3OUT_SetDigitalInput()    do { TRISC6 = 1; } while(0)
#define PWM3OUT_SetDigitalOutput()   do { TRISC6 = 0; } while(0)

#define PWM3OUT_SetPullup()    do { WPUC6 = 1; } while(0)
#define PWM3OUT_ResetPullup()   do { WPUC6 = 0; } while(0)
#define PWM3OUT_SetAnalogMode()   do { ANSC6 = 1; } while(0)
#define PWM3OUT_SetDigitalMode()   do { ANSC6 = 0; } while(0)
// get/set OPA2INPos aliases
#define OPA2INPos_TRIS               TRISC7
#define OPA2INPos_LAT                LATC7
#define OPA2INPos_PORT               RC7
#define OPA2INPos_WPU                WPUC7
#define OPA2INPos_ANS                ANSC7
#define OPA2INPos_SetHigh()    do { LATC7 = 1; } while(0)
#define OPA2INPos_SetLow()   do { LATC7 = 0; } while(0)
#define OPA2INPos_Toggle()   do { LATC7 = ~LATC7; } while(0)
#define OPA2INPos_GetValue()         RC7
#define OPA2INPos_SetDigitalInput()    do { TRISC7 = 1; } while(0)
#define OPA2INPos_SetDigitalOutput()   do { TRISC7 = 0; } while(0)

#define OPA2INPos_SetPullup()    do { WPUC7 = 1; } while(0)
#define OPA2INPos_ResetPullup()   do { WPUC7 = 0; } while(0)
#define OPA2INPos_SetAnalogMode()   do { ANSC7 = 1; } while(0)
#define OPA2INPos_SetDigitalMode()   do { ANSC7 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize(void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
 */